from sharpy.knowledges import KnowledgeBot
from sharpy.plans import BuildOrder
from paul_plans.operations import BanelingDropMain
from sc2.ids.unit_typeid import UnitTypeId
from sc2.position import Point2


class PaulBot(KnowledgeBot):
    def __init__(self):
        super(PaulBot, self).__init__("bane_drop")

    async def create_plan(self) -> "BuildOrder":
        return BuildOrder(BanelingDropMain())

    async def on_start(self):
        await self.real_init()

        await self.knowledge.ai._client.debug_create_unit(
            [[UnitTypeId.OVERLORDTRANSPORT, 1, self.knowledge.ai.game_info.map_center, 1]]
        )
        await self.knowledge.ai._client.debug_create_unit(
            [[UnitTypeId.BANELING, 4, self.knowledge.ai.game_info.map_center, 1]]
        )

        await self.knowledge.ai._client.debug_god()
