from sc2.ids.unit_typeid import UnitTypeId
from sc2.ids.upgrade_id import UpgradeId
from sharpy.managers.build_detector import EnemyRushBuild
from sharpy.plans import BuildOrder, SequentialList, Step, StepBuildGas
from sharpy.plans.acts import ActBuilding, Expand, Tech, DefensiveBuilding, DefensePosition
from sharpy.plans.acts.zerg import ZergUnit
from sharpy.plans.require import UnitExists
from sharpy.plans.tactics import PlanDistributeWorkers


class GenericMacroOpening(BuildOrder):
    """
    17 hatch, 18 gas, 17 pool opening with 4 lings, 2 queens, and ling speed.
    """
    def __init__(self):
        opening = SequentialList(
            ZergUnit(UnitTypeId.DRONE, to_count=13),
            ZergUnit(UnitTypeId.OVERLORD, to_count=2),
            ZergUnit(UnitTypeId.DRONE, to_count=17),
            Expand(2),
            ZergUnit(UnitTypeId.DRONE, to_count=18, only_once=True),
            StepBuildGas(1),
            ActBuilding(UnitTypeId.SPAWNINGPOOL, to_count=1),
            ZergUnit(UnitTypeId.DRONE, to_count=20),
            ZergUnit(UnitTypeId.OVERLORD, to_count=3),
            BuildOrder(
                [
                    Step(
                        UnitExists(UnitTypeId.SPAWNINGPOOL, include_pending=False),
                        ZergUnit(UnitTypeId.QUEEN, to_count=2),
                    ),
                    Step(
                        UnitExists(UnitTypeId.SPAWNINGPOOL, include_pending=False),
                        ZergUnit(UnitTypeId.ZERGLING, to_count=4),
                    ),
                ]
            ),
        )

        upgrades = Tech(UpgradeId.ZERGLINGMOVEMENTSPEED)

        super(GenericMacroOpening, self).__init__(upgrades, opening, PlanDistributeWorkers())
