"""Very basic inject scheme. For each hatch, find the closest queen and have it inject."""
from typing import TYPE_CHECKING
from sharpy.plans.acts import ActBase
from sc2.ids.unit_typeid import UnitTypeId
from sc2.ids.ability_id import AbilityId


if TYPE_CHECKING:
    from sharpy.knowledges import Knowledge


class CustomInject(ActBase):
    def __init__(self):
        super(CustomInject, self).__init__()

    async def start(self, knowledge: "Knowledge"):
        await super().start(knowledge)

    async def execute(self) -> bool:
        queens = self.cache.own(UnitTypeId.QUEEN)
        used_queens = []
        for hq in self.ai.townhalls:
            available_queens = queens.closer_than(15, hq.position).filter(lambda q: q.tag not in used_queens)
            if not available_queens:
                continue
            closest_queen = available_queens.closest_to(hq.position)
            if closest_queen:
                self.ai.do(closest_queen(AbilityId.EFFECT_INJECTLARVA, hq))
                used_queens.append(closest_queen.tag)
        return True
