from sharpy.plans import SequentialList, Step, StepBuildGas
from sharpy.plans.require import Supply, UnitExists
from sharpy.plans.acts import CancelBuilding
from sharpy.plans.acts.zerg import ZergUnit
from sc2.ids.unit_typeid import UnitTypeId

EXTRACTOR_TRICK = SequentialList(
            [
                Step(
                    Supply(14),
                    StepBuildGas(1),
                    skip=UnitExists(UnitTypeId.EXTRACTOR, include_killed=True, include_pending=True),
                ),
                Step(
                    UnitExists(UnitTypeId.EXTRACTOR, 1, include_pending=True, include_not_ready=True,),
                    ZergUnit(UnitTypeId.DRONE, to_count=14),
                ),
                # SequentialList will take care of making sure the drone was made
                Step(
                    UnitExists(UnitTypeId.EXTRACTOR),
                    CancelBuilding(UnitTypeId.EXTRACTOR, to_count=0),
                    skip=UnitExists(UnitTypeId.EXTRACTOR, 1, include_killed=True, include_not_ready=False,),
                ),
            ]
        )
